#include<bits/stdc++.h>
using namespace std;
int o,a,b,ab,n,t[100000], zbiro,zbira,zbirb,zbirab;
string pacijenti[100000];
int pojedniacna_kol[1100000];

int main()
{
  zbiro=0;
  zbira=0;
  zbirb=0;
  zbirab=0;

  cin >> n;
  cin >> o >> a >> b >> ab;
  for(int i=0; i<n; i++)
  {
    cin >> pacijenti[i] >> t[i];
    if(pacijenti[i]=="O")
    {
      zbiro=zbiro+t[i];
      pojedniacna_kol[i]=t[i];
    }

    if(pacijenti[i]=="A")
    {
      zbira=zbira+t[i];
      pojedniacna_kol[i]=t[i];
    }

      if(pacijenti[i]=="B")
    {
      zbirb=zbirb+t[i];
      pojedniacna_kol[i]=t[i];
    }

      if(pacijenti[i]=="AB")
    {
      zbirab=zbirab+t[i];
      pojedniacna_kol[i]=t[i];
    }
  }

  if(zbiro>o)
  {
    cout << "nemoguce" << endl;
    return 0;
  }
  o=o-zbiro;


  if(a-zbira<0)
  {
    if((a+o)-zbira<0 )//a je kolko imam zbira kolko treba
    {
      cout << "nemoguce" << endl;
      o=o-a-zbira;
      zbira=zbira-a;
      return 0;
    }
  }
  zbira=zbira-a;



  if(b-zbirb<0)
  {
    if((b+o)-zbirb<0 )//a je kolko imam zbira kolko treba
    {
      cout << "nemoguce" << endl;
      o=o-(b-zbirb);
      zbirb=zbirb-b;
      return 0;
    }
  }
  zbirb=zbirb-b;


  if((ab+a+b+o)-zbirab<0)
  {
    cout << "nemoguce" << endl;
    return 0;
  }
  else
  {
    cout << "moguce" << endl;
    for(int i=0; i<n; i++)
    {
      if(pacijenti[i]=="O")
      {
        cout << pojedniacna_kol[i] << " 0 0 0" << endl;
        o=o-pojedniacna_kol[i];
      }
      if(pacijenti[i]=="A")
      {
        cout << "0 " << pojedniacna_kol[i] << " 0 0" << endl;
      }

      if(pacijenti[i]=="B")
      {
        cout << "0 0 " << pojedniacna_kol[i] << " 0" << endl;
      }

      if(pacijenti[i]=="AB")
      {
        cout << "0 0 0 " << pojedniacna_kol[i] << endl;
      }
    }

  }
  return 0;
}
/// ispis za proveru
//for(int i=0; i<n; i++)
//   {
//      cout << pacijenti[i] << " " << pojedniacna_kol[i] << endl;
//   }